/**
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import ModelObject from './ModelObject';
import VehicleType from './VehicleType';

/**
* The Body model module.
* @module model/Body
* @version 2020-05-31T17:48:12Z
*/
export default class Body {
    /**
    * Constructs a new <code>Body</code>.
    * @alias module:model/Body
    * @class
    */

    constructor() {
        
        AnyOfbody.call(this);
        
    }

    /**
    * Constructs a <code>Body</code> from a plain JavaScript object, optionally creating a new instance.
    * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
    * @param {Object} data The plain JavaScript object bearing properties of interest.
    * @param {module:model/Body} obj Optional instance to populate.
    * @return {module:model/Body} The populated <code>Body</code> instance.
    */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Body();
                        
            
            if (data.hasOwnProperty('source')) {
                obj['source'] = ApiClient.convertToType(data['source'], 'String');
            }
            if (data.hasOwnProperty('polyline')) {
                obj['polyline'] = ApiClient.convertToType(data['polyline'], 'String');
            }
            if (data.hasOwnProperty('path')) {
                obj['path'] = ApiClient.convertToType(data['path'], 'String');
            }
            if (data.hasOwnProperty('vehicleType')) {
                obj['vehicleType'] = VehicleType.constructFromObject(data['vehicleType']);
            }
            if (data.hasOwnProperty('departure_time')) {
                obj['departure_time'] = ApiClient.convertToType(data['departure_time'], ModelObject);
            }
        }
        return obj;
    }

    /**
    * Specify route source, either <code>here</code> for HERE maps routes based polyline or <code>gmaps</code> for Google Maps polylines
    * @member {module:model/Body.SourceEnum} source
    * @default 'here'
    */
    'source' = 'here';
    /**
    * Specify route as Google Maps encoded polyline (<a href=\"https://developers.google.com/maps/documentation/utilities/polylinealgorithm\" target=\"_blank\">see details</a>)
    * @member {String} polyline
    */
    'polyline' = undefined;
    /**
    * Specify route as a set of comma-separated <strong><code>lat,lng</code></strong> coordinates delimited by a pipe character (|)
    * @member {String} path
    */
    'path' = undefined;
    /**
    * @member {module:model/VehicleType} vehicleType
    */
    'vehicleType' = undefined;
    /**
    * @member {module:model/ModelObject} departure_time
    */
    'departure_time' = undefined;

    // Implement AnyOfbody interface:
    

    /**
    * Allowed values for the <code>source</code> property.
    * @enum {String}
    * @readonly
    */
    static SourceEnum = {
        /**
         * value: "here"
         * @const
         */
        "here": "here",
        /**
         * value: "gmap"
         * @const
         */
        "gmap": "gmap"    };

}
