/**
 * TollGuru Calculator
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import RouteResponseSummaryDiffs from './RouteResponseSummaryDiffs';
import RouteResponseSummaryDistance from './RouteResponseSummaryDistance';
import RouteResponseSummaryDuration from './RouteResponseSummaryDuration';

/**
* The RouteResponseSummary model module.
* @module model/RouteResponseSummary
* @version 2020-05-31T17:48:12Z
*/
export default class RouteResponseSummary {
    /**
    * Constructs a new <code>RouteResponseSummary</code>.
    * summary including distance, time (duration), name, whether the route has tolls (hasTolls), diffs object that shows the difference between the cost between the cheapest route and current route and difference in duration between the current route and the fastest route
    * @alias module:model/RouteResponseSummary
    * @class
    */

    constructor() {
        
        
        
    }

    /**
    * Constructs a <code>RouteResponseSummary</code> from a plain JavaScript object, optionally creating a new instance.
    * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
    * @param {Object} data The plain JavaScript object bearing properties of interest.
    * @param {module:model/RouteResponseSummary} obj Optional instance to populate.
    * @return {module:model/RouteResponseSummary} The populated <code>RouteResponseSummary</code> instance.
    */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new RouteResponseSummary();
                        
            
            if (data.hasOwnProperty('hasTolls')) {
                obj['hasTolls'] = ApiClient.convertToType(data['hasTolls'], 'Boolean');
            }
            if (data.hasOwnProperty('diffs')) {
                obj['diffs'] = RouteResponseSummaryDiffs.constructFromObject(data['diffs']);
            }
            if (data.hasOwnProperty('url')) {
                obj['url'] = ApiClient.convertToType(data['url'], 'String');
            }
            if (data.hasOwnProperty('duration')) {
                obj['duration'] = RouteResponseSummaryDuration.constructFromObject(data['duration']);
            }
            if (data.hasOwnProperty('distance')) {
                obj['distance'] = RouteResponseSummaryDistance.constructFromObject(data['distance']);
            }
            if (data.hasOwnProperty('name')) {
                obj['name'] = ApiClient.convertToType(data['name'], 'String');
            }
            if (data.hasOwnProperty('note')) {
                obj['note'] = ApiClient.convertToType(data['note'], ['String']);
            }
        }
        return obj;
    }

    /**
    * @member {Boolean} hasTolls
    */
    'hasTolls' = undefined;
    /**
    * @member {module:model/RouteResponseSummaryDiffs} diffs
    */
    'diffs' = undefined;
    /**
    * @member {String} url
    */
    'url' = undefined;
    /**
    * @member {module:model/RouteResponseSummaryDuration} duration
    */
    'duration' = undefined;
    /**
    * @member {module:model/RouteResponseSummaryDistance} distance
    */
    'distance' = undefined;
    /**
    * @member {String} name
    */
    'name' = undefined;
    /**
    * @member {Array.<String>} note
    */
    'note' = undefined;




}
